#pragma once

class ArrayEnumPins : public equis::BaseUnknown, public IEnumPins
{
    BASEUNKNOWN_DECLARE(BaseUnknown)
public:
    ArrayEnumPins(IPin** pins, ULONG length);
    virtual ~ArrayEnumPins();

    // IEnumPins
    STDMETHOD(Next)(ULONG length, IPin** pins, ULONG* used);
    STDMETHOD(Skip)(ULONG length);
    STDMETHOD(Reset)(VOID);
    STDMETHOD(Clone)(IEnumPins** pins);

private:
    IPin** m_pins;
    ULONG m_length;
    ULONG m_index;
};

#define IN_DSHOW_ARRAYENUMPINS_HPP
#include "ArrayEnumPins.inl"
#undef IN_DSHOW_ARRAYENUMPINS_HPP
