#ifndef EQUIS_COMMON_HPP
#define EQUIS_COMMON_HPP

#include "config.hpp"

/* Standard C headers. */
#include <cmath>
#include <cstddef>
#include <cstdio>
#include <cstdlib>

/* Standard C++ headers. */
#include <algorithm>
#include <functional>

namespace equis {
	using namespace ::std;
};

/* Equis core headers. */
#include "macros.hpp"
#include "types.hpp"
#include "casts.hpp"
#include "math.hpp"

/* Equis utility headers. */
#include "array.hpp"
#include "array2.hpp"

#ifdef HAVE_WIN32
#include "win32/common.hpp"
#endif /* HAVE_WIN32 */

#endif /* EQUIS_COMMON_HPP */
