#pragma once

// Will be posted by RunMessageLoop when no other messages are pending.
#define WM_IDLE (WM_USER+1)

__declspec(noreturn)
void ReportError(HWND window, LPCTSTR format, ...);

LPCTSTR GetLastErrorString();

HWND CreateDisplayWindow(HINSTANCE instance, long width, long height);

int RunMessageLoop(HWND window);

// Defined in Main.cpp
void DisplayPaint(HWND window, HDC dc, BOOL erase, RECT region);
void DisplayIdle(HWND window);