#pragma once

#include "Input_VideoDevice.hpp"
#include "Input_VideoFormat.hpp"

EQUIS_ENTER_NS3(Equis,Xna,Input);

public ref class Video
{
public:
	//static Video ^FromCapture(VideoDevice ^captureDevice);
	static Video ^FromCapture(String ^devicePath);

	/// BUG: Not implemented.
	static Video ^FromFile(String ^filename);

	PROPERTY_RO(VideoFormat ^, Format);
	bool NextFrame(Texture2D ^texture);

internal:
	explicit Video(EVInput *source);
	~Video();

private:
	EVInput *m_source;
};

EQUIS_LEAVE_NS3(Equis,Xna,Input);
